%TITLE "Final Project    CIS 40A    Spring 2000"
%Title "By Jonathan O'Brien and Jim Reed"

        IDEAL

        MODEL   small
        Stack	256

        p386        
        
        BufSize         EQU     5        

STRUC SBuffer
	Max_Length	db	BufSize
	S_Length	db	0
	Char		db	BufSize DUP (?)
ENDS SBuffer

        DATASEG

exCode          db      0
welcome         db      13,10,'Convert decimal and Hexadecimal values'
                db      13,10,' Press enter to end program.',0
prompt          db      13,10,10, 'Number to convert: ',0
error           db      13, 10, 'Illegal entry', 0
hex             db      13, 10, 'Hexadecimal: ', 0
decimal         db      13, 10, 'Decimal: ', 0
sdecimal        db      13, 10, 'Signed Decimal: ', 0

value	 	dw	?
response        db      5 DUP (?)
buffer		SBuffer <>

	CODESEG
;------------------------------------------------------------------
;       CharsIn returns number of characters in buffer
;------------------------------------------------------------------
proc    CharsIn
	push	ax
	push	di
	xor	al, al
	mov	cx, 0ffffh
	cld
	repnz	scasb
	not	cx
	dec	cx
	pop	di
	pop	ax
	ret
ENDP    CharsIn
;------------------------------------------------------------------

;------------------------------------------------------------------
;       BufferRead inserts characters into buffer
;------------------------------------------------------------------
proc    BufferRead
	or	cl, cl
	jz	@@99
        pusha 
	mov	[buffer.Max_Length], cl
	mov	ah, 0ah
	mov	dx, OFFSET buffer.Max_Length
	int	21h
	xor	bh, bh
	mov	bl, [buffer.S_Length]
        mov     [bx + buffer.Char], 0
	mov	si, OFFSET buffer.Char
	call	Copy       
        popa
@@99:
	ret
ENDP    BufferRead           
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Move increments the pointer location by one
;------------------------------------------------------------------
proc	Move
	jcxz	@@99
        pusha
        add     si, bx
        add     di, dx          
        cld                     
        rep     movsb
        popa
@@99:
	ret
ENDP	Move
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Copy used in BufferRead to copy characters into buffer
;------------------------------------------------------------------
proc	Copy
        pusha
        xchg    si, di
        call    CharsIn       
        inc     cx              
        xchg    si, di          
        xor     bx, bx          
        xor     dx, dx     
	call	Move
        popa
        ret
ENDP	Copy
;------------------------------------------------------------------

;------------------------------------------------------------------
;       BufferWrite displays buffer contents to screen
;------------------------------------------------------------------
proc    BufferWrite
        call    CharsIn
        pusha
        mov	bx, 1
	mov	dx, di
	mov	ah, 40h
	int	21h
        popa
        ret
ENDP    BufferWrite
;------------------------------------------------------------------

;------------------------------------------------------------------
;       NewLine moves cursor to start of next line
;------------------------------------------------------------------
proc	NewLine
	mov	ah, 2
        mov     dl, 13
	int	21h
        mov     dl, 10
	int	21h
	ret
ENDP	NewLine
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Hex? changes numbers 10 - 15 to A - F
;------------------------------------------------------------------
proc	Hex?
	cmp	dl, 10
	jb	@@10
	add	dl, 'A' - 10
	ret
@@10:
	or	dl, '0'
	ret
ENDP	Hex?
;------------------------------------------------------------------

;------------------------------------------------------------------
;       NumASCII converts from binary to base in bx
;------------------------------------------------------------------
proc	NumASCII
        pusha
        xor	si, si
	jcxz	@@30
@@10:
	xor	dx, dx
	div	bx
	call	Hex?
	push	dx
	inc	si
	loop	@@10
@@20:
	inc	cx
	or	ax, ax
	jnz	@@10
	mov	cx, si
	jcxz	@@40
	cld
@@30:
	pop	ax
	stosb
	loop	@@30
@@40:
        mov     [byte di], 0
        popa
        ret
ENDP	NumASCII
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Upper changes all hex number characters to upper case
;------------------------------------------------------------------
proc	Upper
        pusha
        call    CharsIn
	jcxz	@@30
	cld
	mov	si, di
@@10:
	lodsb
	cmp	al, 'a'
	jb	@@20
	cmp	al, 'z'
	ja	@@20
	sub	al, 'a' - 'A'
@@20:
	stosb
	loop	@@10
@@30:
        popa
        ret
ENDP    Upper
;------------------------------------------------------------------

;------------------------------------------------------------------
;       ASCIIBin changes user input to binary
;------------------------------------------------------------------
proc	ASCIIBin
        push    bx
        push    cx
        push    dx
        push    si
        call	Upper
        call    CharsIn
	xor	ax, ax
	jcxz	@@30
	mov	si, di
	add	si, cx
	cmp	[byte di], '-'
	pushf
        jne     @@10
	inc	di
@@10:
	call	Base
	call	ASCIINum
	rcl	bx, 1
	popf
        jne     @@20
	neg	ax
	dec	di
@@20:
        rcr     bx, 1
@@30:
        pop     si
        pop     dx
        pop     cx
        pop     bx
        ret
ENDP	ASCIIBin
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Base sets the base in bx
;------------------------------------------------------------------
proc	Base
	mov	dl, [byte si - 1]
	mov	bx, 16
	cmp	dl, 'H'
        je      @@10
	mov	bx, 10
	cmp	dl, 'D'
        jne     @@20
@@10:
	dec	si
@@20:
	ret
ENDP	Base
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Binary changes each digit to binary value
;------------------------------------------------------------------
proc    Binary
	cmp	dl, '9'
	jbe	@@10
	sub	dl, 7
@@10:
	sub	dl, '0'
	test	dl, 0F0h
	jnz	@@20
	xor	dh, dh
	cmp	dx, bx
@@20:
	cmc
	ret
ENDP    Binary
;------------------------------------------------------------------

;------------------------------------------------------------------
;       ASCIINum changes user input to binary
;------------------------------------------------------------------
proc	ASCIINum
	mov	cx, 1
@@10:
	cmp	si, di
	je	@@20
	dec	si
	mov	dl, [byte si]
        call    Binary
	jc	@@20
	push	cx
	xchg	ax, cx
	mul	dx
	add	cx, ax
	pop	ax
	mul	bx	
	xchg	ax, cx
	jmp	@@10
@@20:
	ret
ENDP	ASCIINum	
;------------------------------------------------------------------

;------------------------------------------------------------------
;       Signed checks to see if user's input is negative
;------------------------------------------------------------------
proc	Signed
	push	bx
	push	di
	cmp	ax, 0
	jge	@@10
	neg	ax
	mov	[byte di], '-'
	inc	di
@@10:
	mov	bx, 10
	call	NumASCII
	pop	di
	pop	bx
	ret
ENDP	Signed
;------------------------------------------------------------------


Start:
	mov	ax, @data
	mov	ds, ax
	mov	es, ax
        mov     di, OFFSET welcome       
        call    BufferWrite                
Runit:
	mov	di, OFFSET Prompt	
        call    BufferWrite
	mov	di, OFFSET response
        mov     cx, 5
        call    BufferRead
	call 	NewLine
        call    CharsIn
	jcxz	Exit
	call	ASCIIBin
	mov	[value], ax
	jnc	Cont
	mov	di, OFFSET error	
        call    BufferWrite
	jmp	Runit
Cont:
	mov	di, OFFSET decimal	
        call    BufferWrite
	mov	ax, [value]
	mov	cx, 1
	mov	di, OFFSET response
	mov	bx, 10
	call	NumASCII	
        call    BufferWrite
	mov	di, OFFSET sdecimal	
        call    BufferWrite
	mov	ax, [value]
	mov	cx, 1
	mov	di, OFFSET response	
	call	Signed
        call    BufferWrite 
	mov	di, OFFSET hex	
        call    BufferWrite
	mov	ax, [value]
	mov	cx, 1
	mov	di, OFFSET response
	mov	bx, 16
	call	NumASCII	
        call    BufferWrite
	jmp	Runit
Exit:
        mov     ah, 04Ch        
        mov     al, [exCode]    
        int     21h             
        END     Start           
